/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.system.controller;

import cn.hutool.core.collection.CollUtil;
import com.alibaba.fastjson.JSONArray;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.checkerframework.checker.units.qual.A;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.system.vo.AreaData;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.system.entity.Area;
import org.springblade.modules.system.vo.AreaVO;
import org.springblade.modules.system.service.IAreaService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.ArrayList;
import java.util.List;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2023-02-09
 */
@RestController
@AllArgsConstructor
@RequestMapping("system/area")
@Api(value = "", tags = "接口")
public class AreaController extends BladeController {

	private final IAreaService areaService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入area")
	public R<Area> detail(Area area) {
		Area detail = areaService.getOne(Condition.getQueryWrapper(area));
		return R.data(detail);
	}

	/**
	 * 分页 
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入area")
	public R<List<Area>> list(Area area, Query query) {
		IPage<Area> pages = areaService.page(Condition.getPage(query), Condition.getQueryWrapper(area));
		return data(pages.getRecords());
	}

	/**
	 * 自定义分页 
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入area")
	public R<IPage<AreaVO>> page(AreaVO area, Query query) {
		IPage<AreaVO> pages = areaService.selectAreaPage(Condition.getPage(query), area);
		return R.data(pages);
	}

	/**
	 * 新增 
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入area")
	public R save(@Valid @RequestBody Area area) {
		return R.status(areaService.save(area));
	}

	/**
	 * 修改 
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入area")
	public R update(@Valid @RequestBody Area area) {
		return R.status(areaService.updateById(area));
	}

	/**
	 * 新增或修改 
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入area")
	public R submit(@Valid @RequestBody Area area) {
		return R.status(areaService.saveOrUpdate(area));
	}

	
	/**
	 * 删除 
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(areaService.removeByIds(Func.toLongList(ids)));
	}

	@GetMapping("getJsonData")
	public R getJsonData() {
		List<Area> list = areaService.lambdaQuery().eq(Area::getPid, 0).list();
		List<AreaData> list1 = this.convert(list);
		for (AreaData areaData : list1) {
			List<Area> list2 = areaService.lambdaQuery().eq(Area::getPid, areaData.getV()).list();
			List<AreaData> convert = this.convert(list2);
			areaData.setC(convert);
			if (CollUtil.isNotEmpty(convert)) {
				for (AreaData data : convert) {
					List<Area> list3 = areaService.lambdaQuery().eq(Area::getPid, data.getV()).list();
					List<AreaData> convert1 = this.convert(list3);
					data.setC(convert1);
				}
			}
		}
		return R.data(list1);
	}

	private List<AreaData> convert(List<Area> list) {
		List<AreaData> a = new ArrayList<>();
		if (CollUtil.isNotEmpty(list)) {
			for (Area area : list) {
				AreaData ad = new AreaData();
				ad.setV(area.getAdcode());
				ad.setN(area.getName());
				a.add(ad);
			}
		}
		return a;
	}

	
}
